/*!
 * @file BufferedWriter.h
 * @brief եν񤭹ߥХåե
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2005-03-22
 *
 * Copyright (C) 2005, Yashiro Takeshi
 */

#ifndef BUFFERED_WRITER_H
#define BUFFERED_WRITER_H

#include <basic.h>
#include <btron/file.h>
#include "Exception.h"

//! եν񤭹ߥХåե
/*!
 * եν񤭹ߤХåե󥰤뤿Υ饹Ǥ
 */
class BufferedWriter {

  W filedes; //!< եǥץ

  static const int bufsize = 1024;

  B buff[bufsize]; //!< 񤭹ߥХåե

  static const int bcur = 0; //!< 񤭹ߥХåեμν񤭹
  int blen; //!< 񤭹ߥХåեΥ

  W offset; //!< եν񤭹֤߰Υեå

 public:

  //! 󥹥ȥ饯
  /*!
   * եǥץХåե󥰤륪֥Ȥޤ
   * @param fd оݤȤʤեǥץ
   */
  BufferedWriter(W fd)
    : filedes(fd), blen(0) {}

  //! 񤭹
  /*!
   * եإǡꤷХĹ񤭹ߤޤ
   * @param target [out] ǡγǼ
   * @param size [in] targetɤ߹ХĹ
   * @exception FileWriteException ե񤭹߻˥顼
   */
  void write(const B* target, int size);

  //! 񤭹(եå)
  /*!
   * Хåե˽񤭹ƤŪ˥ե˽(եå)ޤ
   * cls_filɬ¹ԤƤ
   * @exception FileWriteException ե񤭹߻˥顼
   */
  void flush();

};

#endif // BUFFERED_WRITER_H
