/*!
 * @file ZoomMenu.h
 * @brief ˥塼
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2004-10-31, first edition (for BSlide)
 * @date 2005-02-27, modified for Scribble
 * @date 2006-05-08, modified for MicroPDF
 *
 * Copyright (C) 2004-2006, Yashiro Takeshi
 */

#ifndef ZOOMMENU_H
#define ZOOMMENU_H

#include <map>
#include <vector>
#include <basic.h>
#include <btron/hmi.h>
#include <btron/libapp.h>

//! ˥塼
/*!
 * ˥塼
 */
class ZoomMenu {

private:

  typedef std::map<int, double> ValueMap;

  ValueMap vmap;

  W mid; //!< ˥塼ID
  
public:

  //! 󥹥ȥ饯
  ZoomMenu();

  //! ǥȥ饯
  ~ZoomMenu(){
    if (mid >= 0){
      mdel_men(mid);
    }
  }
  
  //! ˥塼IDμ
  /*!
   * ƥॳǻȤΥ˥塼IDޤ
   * @return ˥塼ID
   */
  W getMenuID() const {
    return mid;
  }
  
  //! ˥塼ֹѴ
  /*!
   * popupMenu ˤ줿˥塼ֹΨѴޤ
   * @param rid ˥塼ֹ
   * @return Ψ
   */
  double getZoomVal(int rid) const;

  //! ˥塼Υݥåץå׼¹
  /*!
   * ˥塼ݥåץå׼¹Ԥ˥塼ֹ֤ޤ
   * @param ev [out] ٥Ȥ¸
   * @return ˥塼ֹ
   */
  W popupMenu(W wid, double zoom);

  //ZoomMenuItem selMenu(WEVENT *ev);
};

#endif // ZOOMMENU_H
