// pictograms (included only from XPDFViewer.cc)

typedef struct tag_pictogram_dbox_entry {
  W compac;
  UW planes;
  H pixbits;
  H rowbytes;
  RECT bounds;
  W off_base;
  B data[256 * 3 + 1];
} pictogram_dbox_entry;

#define XtOffset(p_type,field) ((unsigned int)&(((p_type*)NULL)->field))

const unsigned int pict_offset = XtOffset(pictogram_dbox_entry,data);

pictogram_dbox_entry pict_gofirst = {
  0, 1, 0x101, 2, {{0, 0, 16, 16}}, pict_offset, 
  {
    0x00, 0x00, 0x60, 0x02, 0x60, 0x0e, 0x60, 0x3e,
    0x60, 0xfe, 0x63, 0xfe, 0x6f, 0xfe, 0x7f, 0xfe,
    0x7f, 0xfe, 0x6f, 0xfe, 0x63, 0xfe, 0x60, 0xfe,
    0x60, 0x3e, 0x60, 0x0e, 0x60, 0x02, 0x00, 0x00,
  }
};

pictogram_dbox_entry pict_goback = {
  0, 1, 0x101, 2, {{0, 0, 16, 16}}, pict_offset, 
  {
    0x00, 0x00, 0x00, 0x06, 0x00, 0x1e, 0x00, 0x7e,
    0x01, 0xfe, 0x07, 0xfe, 0x1f, 0xfe, 0x7f, 0xfe,
    0x7f, 0xfe, 0x1f, 0xfe, 0x07, 0xfe, 0x01, 0xfe,
    0x00, 0x7e, 0x00, 0x1e, 0x00, 0x06, 0x00, 0x00,
  }
};

pictogram_dbox_entry pict_gonext = {
  0, 1, 0x101, 2, {{0, 0, 16, 16}}, pict_offset, 
  {
    0x00, 0x00, 0x60, 0x00, 0x78, 0x00, 0x7e, 0x00,
    0x7f, 0x80, 0x7f, 0xe0, 0x7f, 0xf8, 0x7f, 0xfe,
    0x7f, 0xfe, 0x7f, 0xf8, 0x7f, 0xe0, 0x7f, 0x80,
    0x7e, 0x00, 0x78, 0x00, 0x60, 0x00, 0x00, 0x00,
  }
};

pictogram_dbox_entry pict_golast = {
  0, 1, 0x101, 2, {{0, 0, 16, 16}}, pict_offset, 
  {
    0x00, 0x00, 0x40, 0x06, 0x70, 0x06, 0x7c, 0x06,
    0x7f, 0x06, 0x7f, 0xc6, 0x7f, 0xf6, 0x7f, 0xfe,
    0x7f, 0xfe, 0x7f, 0xf6, 0x7f, 0xc6, 0x7f, 0x06,
    0x7c, 0x06, 0x70, 0x06, 0x40, 0x06, 0x00, 0x00,
  }
};

